using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace Canvas
{
    public static class Calculations
    {
        public static PointF HelpPoint(PointF P1, PointF P2, int Distance)
        {
            Double x1 = P1.X;
            Double y1 = P1.Y;
            Double x2 = P2.X;
            Double y2 = P2.Y;

            Double xD;
            Double yD;
            Double xZ;
            Double yZ;
            if ((x1 != x2) && (y1 == y2))
            {
                xZ = (x1 + x2);
                xD = xZ / 2;
                yZ = y1;
                yD = yZ - Distance;
            }
            else if ((x1 == x2) && (y1 != y2))
            {
                xZ = x1;
                xD = xZ - Distance;
                yZ = (y1 + y2);
                yD = yZ / 2;
            }
            else
            {

                Double xH = (x1 + x2) / 2;
                Double yH = (y1 + y2) / 2;
                Double m = (double)(y2 - y1) / (double)(x2 - x1);
                Double mD = 1 / -m;
                Double nD = yH - mD * xH;
                Double y2D = mD * x2 + nD;
                Double l = Math.Sqrt((xH - x2) * (xH - x2) + (yH - y2D) * (yH - y2D));
                Double lNorm = Distance;
                Double v = lNorm / l;
                xD = (int)(xH - v * (xH - x2));
                yD = (int)(yH - v * (yH - y2D));
            }
            PointF DrawPoint = new PointF((float)xD, (float)yD);
            return DrawPoint;
        }
        public static double Distance(PointF P1, PointF P2)
        {
            return Math.Sqrt((P1.X - P2.X) * (P1.X - P2.X) + (P1.Y - P2.Y) * (P1.Y - P2.Y));
        }
        public static PointF RotatePoint(PointF P, PointF RotatePoint, Double Angle)
        {
            P.X = P.X - RotatePoint.X;
            P.Y = P.Y - RotatePoint.Y;
            Double XD=Math.Cos(Angle) * P.X - Math.Sin(Angle) * P.Y;
            Double YD=Math.Sin(Angle) * P.X + Math.Cos(Angle) * P.Y;
            P.X = (float)XD;
            P.Y = (float)YD;
            P.X = P.X + RotatePoint.X;
            P.Y = P.Y + RotatePoint.Y;
            return P;
        }
        public static Double CalculateAngle(PointF P1, PointF P2)
        {
            Double m1 = P1.Y - P2.Y;
            Double m2 = P1.X - P2.X;
            Double angle;
            if (m2 != 0)
            {
                Double m = m1 / m2;
                angle = Math.Atan(m);
            }
            else
            {
                angle = Math.PI / 2;
            }
            return angle;
        }
        public static Double CalculateIncrease(PointF P1, PointF P2)
        {
            Double m1 = P1.Y - P2.Y;
            Double m2 = P1.X - P2.X;
            Double m = 0;
            if (m2 != 0)
            {
               m = m1 / m2;
               
            }
            return m;
        }
        public static bool PointOnLine(int x, int y, PointF P1, PointF P2)
        {
                Double CrossX, CrossY;
                int CatchRange = 4;
                float X1 = P1.X;
                float X2 = P2.X;
                float Y1 = P1.Y;
                float Y2 =P2.Y;
                if (X1 == X2)
                {
                    if (Y1 == Y2)
                    {
                        if (Math.Sqrt((X1 - x) * (X1 - x) + (Y1 - y) * (Y1 - y)) < CatchRange)
                        {
                            return true;
                        }
                        else
                        {
                            return false;
                        }
                    }
                    else
                    {
                        if (((Math.Abs(X1 - x) < CatchRange) && (((Y1 > Y2) && (Y1 >= y) && (Y2 <= y)) | ((Y1 < Y2) && (Y1 <= y) && (Y2 >= y)))) | (Math.Sqrt((X1 - x) * (X1 - x) + (Y1 - y) * (Y1 - y)) < CatchRange) | (Math.Sqrt((X2 - x) * (X2 - x) + (Y2 - y) * (Y2 - y)) < CatchRange))
                        {
                            return true;
                        }
                        else
                        {
                            return false;
                        }
                    }
                }
                else
                {
                    if (Y1 == Y2)
                    {
                        if (((Math.Abs(Y1 - y) < CatchRange) && (((X1 > X2) && (X1 >= x) && (X2 <= x)) | ((X1 < X2) && (X1 <= x) && (X2 >= x)))) | (Math.Sqrt((X1 - x) * (X1 - x) + (Y1 - y) * (Y1 - y)) < CatchRange) | (Math.Sqrt((X2 - x) * (X2 - x) + (Y2 - y) * (Y2 - y)) < CatchRange))
                        {
                            return true;
                        }
                        else
                        {
                            return false;
                        }

                    }
                    else
                    {
                        CrossX = ((y - Y2) * (X1 - X2) * (Y1 - Y2) - x * (X1 - X2) * (X2 - X1) + X2 * (Y1 - Y2) * (Y1 - Y2)) / ((Y1 - Y2) * (Y1 - Y2) - (X1 - X2) * (X2 - X1));
                        CrossY = y + (X2 - X1) * (CrossX - x) / (Y1 - Y2);
                        if ((Math.Sqrt((CrossX - x) * (CrossX - x) + (CrossY - y) * (CrossY - y)) < CatchRange) && ((((X1 < X2) && (X1 <= CrossX) && (X2 >= CrossX)) | ((X1 > X2) && (X1 >= CrossX) && (X2 <= CrossX))) && (((Y1 < Y2) && (Y1 <= CrossY) && (Y2 >= CrossY)) | ((Y1 > Y2) && (Y1 >= CrossY) && (Y2 <= CrossY)))) | (Math.Sqrt((X1 - x) * (X1 - x) + (Y1 - y) * (Y1 - y)) < CatchRange) | (Math.Sqrt((X2 - x) * (X2 - x) + (Y2 - y) * (Y2 - y)) < CatchRange))
                        {
                            return true;
                        }
                        else
                        {
                            return false;
                        }
                    }
                }    
        }
        public static double DegToRadian(double Angle)
        {
            return 2 * Math.PI * Angle / 360;
        }
        
        public static RectangleF CreateRectangle(PointF P1, PointF P2)
        {
            float width;
            float heigth;
            width = Math.Abs(P1.X - P2.X);
            heigth = Math.Abs(P1.Y - P2.Y);
            return new RectangleF(P1.X, P1.Y, width, heigth);
            
        }
    }
    public abstract class BasicObject
    {
        public BasicObject()
        {
            Visible = true;
            numberOfKnownPoints = true;
        }
        public enum StateTyp { normal, select, shift, edit, rotate };
        public enum ObjectTyp { Triangle, Circle, Square, MyRectangle, Line, Ellypse, Quadrangle };
        private int numberOfPoints;
        private Boolean ready = false;
        private Boolean visible;
        private StateTyp state;
        protected Color color;
        protected PointF[] fp;
        protected int More = -1;
        protected bool numberOfKnownPoints;
        public Boolean Ready
        {
            set
            {
                ready = value;
            }
            get
            {
                return ready;
            }
        }
        public int NumberOfPoints
        {
            get
            {
                return numberOfPoints;
            }
            set
            {
                numberOfPoints = value;
            }
        }
        public bool NumberOfKnownPoints
        {
            get
            {
                return numberOfKnownPoints;
            }
        }
        public Boolean Visible
        {
            get
            {
                return visible;
            }
            set
            {
                visible = value;
            }
        }
        public void SetPoint(PointF Value, int Index)
        {
            fp[Index] = Value;
        }
        public StateTyp State
        {
            set
            {
                state = value;
            }
            get
            {
                return state;
            }

        }
        protected Brush FBrush = new SolidBrush(Color.Red);
        protected const int sizeOfSelectPoints = 3;
        protected Color GetColor(StateTyp Value)
        {
            Color ColorTmp;
            switch (Value)
            {
                case StateTyp.normal:
                    ColorTmp = Color.Black;
                    break;
                case StateTyp.select:
                    ColorTmp = Color.Red;
                    break;
                case StateTyp.shift:
                    ColorTmp = Color.Green;
                    break;
                default:
                    ColorTmp = Color.Black;
                    break;
            }
            return ColorTmp;
        }
        protected void DrawExtraPoint(Graphics Grafic, Pen Pen, PointF P)
        {
            RectangleF R = new RectangleF(P.X - sizeOfSelectPoints, P.Y - sizeOfSelectPoints, 2 * sizeOfSelectPoints, 2 * sizeOfSelectPoints);
            Grafic.FillRectangle(FBrush, Rectangle.Round(R));
        }
        protected void DrawSelectedPoint(Graphics Graphic, Pen Pen, Boolean WithRotatePoint)
        {
            for (int i = 0; i < NumberOfPoints; i++)
            {
                DrawExtraPoint(Graphic, Pen, fp[i]);
            }
            if (WithRotatePoint == true)
            {
                PointF RotatePoint = Calculations.HelpPoint(fp[0], fp[1], 40);
                DrawExtraPoint(Graphic, Pen, RotatePoint);
                PointF HelpPoint = new PointF(0, 0);
                HelpPoint.X = (fp[0].X + fp[1].X) / 2;
                HelpPoint.Y = (fp[0].Y + fp[1].Y) / 2;
                Graphic.DrawLine(Pen, HelpPoint, RotatePoint);
            }
        }
        public void Shift(int dx, int dy)
        {
            for (int i = 0; i < NumberOfPoints; i++)
            {
                if ((fp[i].X + dx) > 0)
                {
                    fp[i].X += dx;
                    fp[i].Y += dy;
                }
            }
        }
        public ObjectTyp GetTyp()
        {
            ObjectTyp typ;
            if (this is Ellypse)
            {
                typ = BasicObject.ObjectTyp.Ellypse;
            }
            else if (this is Circle)
            {
                typ = BasicObject.ObjectTyp.Circle;
            }
            else if (this is Quadrangle)
            {
                typ = BasicObject.ObjectTyp.Quadrangle;
            }
            else if (this is MyRectangle)
            {
                typ = BasicObject.ObjectTyp.MyRectangle;
            }
            else if (this is Square)
            {
                typ = BasicObject.ObjectTyp.Square;
            }
            else if (this is Triangle)
            {
                typ = BasicObject.ObjectTyp.Triangle;
            }
            else
            {
                typ = BasicObject.ObjectTyp.Line;
            }
            return typ;
        }
        public abstract Boolean CheckForObject(int x, int y);
        protected virtual PointF CalculateCenter()
        {
            PointF P = new PointF(0, 0);
            for (int i = 0; i < NumberOfPoints; i++)
            {
                P.X = P.X + fp[i].X;
                P.Y = P.Y + fp[i].Y;
            }
            P.X = P.X / NumberOfPoints;
            P.Y = P.Y / NumberOfPoints;
            return P;
        }
        public virtual void Draw(Graphics Graphic)
        {
            color = GetColor(state);
            Pen Stift = new Pen(color);
            for (int i = 0; i < NumberOfPoints - 1; i++)
            {
                Graphic.DrawLine(Stift, fp[i], fp[i + 1]);
            }
            if (state == StateTyp.select)
            {
                DrawSelectedPoint(Graphic, Stift, true);
            }
        }
        public virtual void EditSize(int Nr, int dx, int dy)
        {
            fp[Nr].X += dx;
            fp[Nr].Y += dy;
        }
        public virtual int CheckForObjectArea(int x, int y)
        {
            int Result = -1;
            for (int i = 0; i < NumberOfPoints; i++)
            {
                RectangleF Rechteck = new RectangleF(fp[i].X - sizeOfSelectPoints, fp[i].Y - sizeOfSelectPoints, 2 * sizeOfSelectPoints, 2 * sizeOfSelectPoints);
                Region FBereich = new Region(Rechteck);
                if (FBereich.IsVisible(x, y) == true)
                {
                    Result = i;
                    break;
                }
            }
            PointF RotatePoint = Calculations.HelpPoint(fp[0], fp[1], 40);
            RectangleF DR = new RectangleF(RotatePoint.X - sizeOfSelectPoints, RotatePoint.Y - sizeOfSelectPoints, 2 * sizeOfSelectPoints, 2 * sizeOfSelectPoints);
            Region FBereich2 = new Region(DR);
            if (FBereich2.IsVisible(x, y) == true)
            {
                Result = -2;
            }
            return Result;
        }
        public virtual void Rotate(Double Angle)
        {
        }
        public virtual void Assign(BasicObject Value)
        {
            Visible = Value.Visible;
            Ready = Value.Ready;
            NumberOfPoints = Value.NumberOfPoints;
            numberOfKnownPoints = Value.numberOfKnownPoints;
            More = Value.More;
            fp = new PointF[NumberOfPoints];
            for (int i = 0; i < NumberOfPoints; i++)
            {
                fp[i] = Value.fp[i];
            }
        }
    }
    public abstract class Figure : BasicObject
    {
        public override void Rotate(Double Winkel)
        {
            PointF RotationPoint = new PointF(0, 0);
            RotationPoint = CalculateCenter();
            for (int i = 0; i < NumberOfPoints; i++)
            {
                PointF P = fp[i];
                P = Calculations.RotatePoint(fp[i], RotationPoint, Winkel);
                fp[i] = P;
            }
        }
    }
    public abstract class nAngle : Figure
    {
        public override Boolean CheckForObject(int x, int y)
        {
            GraphicsPath gp = new GraphicsPath();
            for (int i = 0; i < NumberOfPoints - 1; i++)
            {
                gp.AddLine(fp[i], fp[i + 1]);
            }
            gp.CloseFigure();
            Region FBereich = new Region(gp);
            if (FBereich.IsVisible(x, y) == true)
                return true;
            else
                return false;
        }
        public override void Draw(Graphics Grafic)
        {
            color = GetColor(State);
            Pen Stift = new Pen(color);
            if (State == StateTyp.normal)
            {
                SolidBrush fuellung = new SolidBrush(Color.Tomato);
                Grafic.FillPolygon(fuellung, fp);
            }
            else
            {
                Grafic.DrawPolygon(Stift, fp);
            }

            if (State == StateTyp.select)
            {
                DrawSelectedPoint(Grafic, Stift, true);
            }
        }
    }
    public abstract class Special : Figure
    {
        public override void EditSize(int Nr, int dx, int dy)
        {
            switch (Nr)
            {
            case 0:
                CalculateCorners(ref fp[0], ref fp[1], ref fp[3], fp[2], dx, dy);
                break;
            case 1:
                CalculateCorners(ref fp[1], ref fp[0], ref fp[2], fp[3], dx, dy);
                break;
            case 2:
                CalculateCorners(ref fp[2], ref fp[1], ref fp[3], fp[0], dx, dy);
                break;
            case 3:
                CalculateCorners(ref fp[3], ref fp[0], ref fp[2], fp[1], dx, dy);
                break;
            default:
                break;
            }
        }
        private void CalculateCorners(ref PointF MovePoint, ref PointF P1, ref PointF P2, PointF FixPoint, int dx, int dy)
        {
            PointF MovePointNeu = new PointF();
            Double m1;
            Double m2;
            if (Math.Abs(FixPoint.X - P1.X) < 0.01)
            {
                MovePoint.X = MovePoint.X + dx;
                MovePoint.Y = MovePoint.Y + dy;
                P1.Y = P1.Y + dy;
                P2.X = P2.X + dx;
            }
            else if (Math.Abs(FixPoint.Y - P1.Y) < 0.01)
            {
                MovePoint.X = MovePoint.X + dx;
                MovePoint.Y = MovePoint.Y + dy;
                P1.X = P1.X + dx;
                P2.Y = P2.Y + dy;
            }
            else
            {
                MovePointNeu.X = MovePoint.X + dx;
                MovePointNeu.Y = MovePoint.Y + dy;
                m1 = Calculations.CalculateIncrease(P1, FixPoint);
                m2 = Calculations.CalculateIncrease(P1, MovePoint);
                P1.X = (float)((m1 * FixPoint.X - FixPoint.Y - m2 * MovePointNeu.X + MovePointNeu.Y) / (m1 - m2));
                P1.Y = (float)(m1 * (P1.X - FixPoint.X) + FixPoint.Y);
                m1 = Calculations.CalculateIncrease(FixPoint, P2);
                m2 = Calculations.CalculateIncrease(MovePoint, P2);
                P2.X = (float)((m1 * FixPoint.X - FixPoint.Y - m2 * MovePointNeu.X + MovePointNeu.Y) / (m1 - m2));
                P2.Y = (float)(m1 * (P2.X - FixPoint.X) + FixPoint.Y);
                MovePoint = MovePointNeu;
            }

        }
    }
    public class Circle : Figure
    {
        public Circle()
        {
            NumberOfPoints = 2;
            fp = new PointF[NumberOfPoints];
        }
        private RectangleF Calculate()
        {
            PointF m = fp[0]; // Mittelpunkt
            Double Abstand = Calculations.Distance(m, fp[1]);
            PointF P1 = new PointF();
            P1.X = (float)(m.X - Abstand);
            P1.Y = (float)(m.Y - Abstand);
            RectangleF R = new RectangleF(P1.X, P1.Y, (float)(2 * Abstand), (float)(2 * Abstand));
            return R;
        }
        public override Boolean CheckForObject(int x, int y)
        {
            GraphicsPath gp = new GraphicsPath();
            RectangleF R = Calculate();
            gp.AddEllipse(R);
            gp.CloseFigure();
            Region FBereich = new Region(gp);
            if (FBereich.IsVisible(x, y) == true)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        public override void Draw(Graphics Grafic)
        {
            color = GetColor(State);
            Pen Stift = new Pen(color);
            RectangleF R = Calculate();
            if (State == StateTyp.normal)
            {
                SolidBrush fuellung = new SolidBrush(Color.PeachPuff);
                Grafic.FillEllipse(fuellung, R);
            }
            else
            {
                Grafic.DrawEllipse(Stift, R);
            }
            if (State == StateTyp.select)
            {
                DrawSelectedPoint(Grafic, Stift, false);
            }
        }
        public override void EditSize(int Nr, int dx, int dy)
        {
            if (Nr == 1)
            {
                fp[1].X += dx;
                fp[1].Y += dy;
            }
        }
        public new void Rotate(double Winkel)
        {

        }
    }
    public class MyLine : Figure
    {
        public MyLine()
        {
            NumberOfPoints = 2;
            fp = new PointF[NumberOfPoints];
        }
        public override Boolean CheckForObject(int x, int y)
        {

            return Calculations.PointOnLine(x, y, fp[0], fp[1]);
        }
    }
    public class Square : Figure
    {
        public Square()
        {
            NumberOfPoints = 2;
            fp = new PointF[NumberOfPoints];
        }
        private void CalculateAnglePoints(ref PointF MovePoint, ref PointF P1, ref PointF P2, PointF FixPoint, int dx, int dy)
        {
            PointF MovePointNeu = new PointF();
            Double m1;
            Double m2;
            PointF pH = new PointF();
            double l;
            double l1;
            double v;
            pH.X = MovePoint.X + dx;
            pH.Y = MovePoint.Y + dy;
            l = Calculations.Distance(FixPoint, MovePoint);
            l1 = Calculations.Distance(FixPoint, pH);
            v = l1 / l;
            MovePointNeu.X = (float)(FixPoint.X + v * (MovePoint.X - FixPoint.X));
            MovePointNeu.Y = (float)(FixPoint.Y + v * (MovePoint.Y - FixPoint.Y));
            if (Math.Abs(FixPoint.X - P1.X) < 0.01)
            {
                P1.Y = MovePointNeu.Y;
                P2.X = MovePointNeu.X;
            }
            else if (Math.Abs(FixPoint.Y - P1.Y) < 0.01)
            {
                P1.X = MovePointNeu.X;
                P2.Y = MovePointNeu.Y;
            }
            else
            {
                m1 = Calculations.CalculateIncrease(P1, FixPoint);
                m2 = Calculations.CalculateIncrease(P1, MovePoint);
                P1.X = (float)((m1 * FixPoint.X - FixPoint.Y - m2 * MovePointNeu.X + MovePointNeu.Y) / (m1 - m2));
                P1.Y = (float)(m1 * (P1.X - FixPoint.X) + FixPoint.Y);
                m1 = Calculations.CalculateIncrease(FixPoint, P2);
                m2 = Calculations.CalculateIncrease(MovePoint, P2);
                P2.X = (float)((m1 * FixPoint.X - FixPoint.Y - m2 * MovePointNeu.X + MovePointNeu.Y) / (m1 - m2));
                P2.Y = (float)(m1 * (P2.X - FixPoint.X) + FixPoint.Y);
            }
            MovePoint = MovePointNeu;
        }
        public override Boolean CheckForObject(int x, int y)
        {
            GraphicsPath gp = new GraphicsPath();
            for (int i = 0; i < NumberOfPoints - 1; i++)
            {
                gp.AddLine(fp[i], fp[i + 1]);
            }
            gp.CloseFigure();
            Region FBereich = new Region(gp);
            if (FBereich.IsVisible(x, y) == true)
                return true;
            else
                return false;
        }
        public override void Draw(Graphics Grafic)
        {
            color = GetColor(State);
            Pen Stift = new Pen(color);
            float abstand;
            PointF hp1 = new PointF();
            if (Ready == false)
            {
                abstand = (float)Calculations.Distance(fp[0], fp[1]);
                RectangleF R = new RectangleF(fp[0].X, fp[0].Y, abstand, abstand);
                Grafic.DrawRectangle(Stift, Rectangle.Round(R));
            }
            else
            {
                if (NumberOfPoints == 2)
                {
                    NumberOfPoints = 4;
                    hp1 = fp[0];
                    abstand = (float)Calculations.Distance(fp[0], fp[1]);
                    fp = new PointF[NumberOfPoints];
                    fp[0] = hp1;
                    fp[2].X = fp[0].X + abstand;
                    fp[2].Y = fp[0].Y + abstand;
                    fp[3].X = fp[0].X;
                    fp[3].Y = fp[2].Y;
                    fp[1].X = fp[2].X;
                    fp[1].Y = fp[0].Y;
                }
                if (State == StateTyp.normal)
                {
                    SolidBrush fuellung = new SolidBrush(Color.Turquoise);
                    Grafic.FillPolygon(fuellung, fp);
                }
                else
                {
                    Grafic.DrawPolygon(Stift, fp);
                }
            }
            if (State == StateTyp.select)
            {
                DrawSelectedPoint(Grafic, Stift, true);
            }
        }
        public override void EditSize(int Nr, int dx, int dy)
        {

            switch (Nr)
            {
                case 0:
                    CalculateAnglePoints(ref fp[0], ref fp[1], ref fp[3], fp[2], dx, dy);
                    break;
                case 1:
                    CalculateAnglePoints(ref fp[1], ref fp[0], ref fp[2], fp[3], dx, dy);
                    break;
                case 2:
                    CalculateAnglePoints(ref fp[2], ref fp[1], ref fp[3], fp[0], dx, dy);
                    break;
                case 3:
                    CalculateAnglePoints(ref fp[3], ref fp[0], ref fp[2], fp[1], dx, dy);
                    break;
                default:
                    break;
            }
        }
    }
    public class Triangle : nAngle
    {
        public Triangle()
        {
            NumberOfPoints = 3;
            fp = new PointF[NumberOfPoints];
        }
    }
    public class Quadrangle : nAngle
    {
        public Quadrangle()
        {
            NumberOfPoints = 4;
            fp = new PointF[NumberOfPoints];
        }
    }
    public class Ellypse : Special
    {
        public Ellypse()
        {
            NumberOfPoints = 2;
            fp = new PointF[NumberOfPoints];
        }        
        private PointF[] points;
        private void Calculate()
        {
            const byte steps = 200;
            Double t;
            Double dt;
            Double a;
            Double b;
            Double winkel;
            PointF mp = fp[0];
            PointF hp1;
            PointF hp2;
            PointF p = new PointF(0, 0);
            winkel = 0;
            if (Ready == false)
            {
                a = (Math.Abs(fp[1].X - fp[0].X)) / 2;
                b = (Math.Abs(fp[1].Y - fp[0].Y)) / 2;
                mp.X = (fp[0].X + fp[1].X) / 2;
                mp.Y = (fp[0].Y + fp[1].Y) / 2;
            }
            else
            {
                if (NumberOfPoints == 2)
                {
                    NumberOfPoints = 4;
                    hp1 = fp[0];
                    hp2 = fp[1];
                    fp = new PointF[NumberOfPoints];
                    fp[0] = hp1;
                    fp[2] = hp2;
                    fp[3].X = fp[0].X;
                    fp[3].Y = fp[2].Y;
                    fp[1].X = fp[2].X;
                    fp[1].Y = fp[0].Y;
                }
                a = (Calculations.Distance(fp[0], fp[1])) / 2;
                b = (Calculations.Distance(fp[0], fp[3])) / 2;
                winkel = Calculations.CalculateAngle(fp[0], fp[1]);
                mp.X = (fp[0].X + fp[2].X) / 2;
                mp.Y = (fp[0].Y + fp[2].Y) / 2;
            }
            
            if (b == 0)
            {
                b = a;
            }
            t = 0;
            dt = 2 * Math.PI / steps;
            points = new PointF[steps + 1];
            PointF RotationPoint = new PointF(0, 0);
            RotationPoint = CalculateCenter();
            int i = 0;
            while (t <= 2 * Math.PI)
            {
                p.X = (int)(mp.X + a * Math.Cos(t));
                p.Y = (int)(mp.Y + b * Math.Sin(t));
                p = Calculations.RotatePoint(p, RotationPoint, winkel);
                points[i] = p;
                i++;
                t = t + dt;
            };
        }
        public override Boolean CheckForObject(int x, int y)
        {
            GraphicsPath gp = new GraphicsPath();
            Calculate();
            gp.AddPolygon(points);
            gp.CloseFigure();
            Region FBereich = new Region(gp);
            if (FBereich.IsVisible(x, y) == true)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        public override void Draw(Graphics Grafic)
        {
            color = GetColor(State);
            Pen Stift = new Pen(color);
            Calculate();
            if (State == StateTyp.normal)
            {
                SolidBrush fuellung = new SolidBrush(Color.Bisque);
                Grafic.FillPolygon(fuellung, points);
            }
            else
            {
                Grafic.DrawPolygon(Stift, points);
            }
            if (State == StateTyp.select)
            {
                for (int i = 0; i < NumberOfPoints - 1; i++)
                {
                    Grafic.DrawLine(Stift, fp[i], fp[i + 1]);
                }
                Grafic.DrawLine(Stift, fp[NumberOfPoints - 1], fp[0]);
                DrawSelectedPoint(Grafic, Stift, true);
            }
        }
    }
    public class MyRectangle : Special
    {
        public MyRectangle()
        {
            NumberOfPoints = 2;
            fp = new PointF[NumberOfPoints];
        }
        public override Boolean CheckForObject(int x, int y)
        {
            GraphicsPath gp = new GraphicsPath();
            for (int i = 0; i < NumberOfPoints - 1; i++)
            {
                gp.AddLine(fp[i], fp[i + 1]);
            }
            gp.CloseFigure();
            Region FBereich = new Region(gp);
            if (FBereich.IsVisible(x, y) == true)
                return true;
            else
                return false;
        }
        public override void Draw(Graphics Grafic)
        {
            color = GetColor(State);
            Pen Stift = new Pen(color);
            PointF hp1 = new PointF();
            PointF hp2 = new PointF();
            if (Ready == false)
            {
                RectangleF r = new RectangleF();
                r = Calculations.CreateRectangle(fp[0], fp[1]);
                Grafic.DrawRectangle(Stift, Rectangle.Round(r));
            }
            else
            {
                if (NumberOfPoints == 2)
                {
                    NumberOfPoints = 4;
                    hp1 = fp[0];
                    hp2 = fp[1];
                    fp = new PointF[NumberOfPoints];
                    fp[0] = hp1;
                    fp[2] = hp2;
                    fp[3].X = fp[0].X;
                    fp[3].Y = fp[2].Y;
                    fp[1].X = fp[2].X;
                    fp[1].Y = fp[0].Y;
                }
                if (State == StateTyp.normal)
                {
                    SolidBrush fuellung = new SolidBrush(Color.YellowGreen);
                    Grafic.FillPolygon(fuellung, fp);
                }
                else
                {
                    Grafic.DrawPolygon(Stift, fp);
                }

            }
            if (State == StateTyp.select)
            {
                DrawSelectedPoint(Grafic, Stift, true);
            }
        }
    }

}
        
       
